#!/bin/sh

################################################################################
##                                                                            ##
## Copyright (c) International Business Machines  Corp., 2005                 ##
##                                                                            ##
## This program is free software;  you can redistribute it and#or modify      ##
## it under the terms of the GNU General Public License as published by       ##
## the Free Software Foundation; either version 2 of the License, or          ##
## (at your option) any later version.                                        ##
##                                                                            ##
## This program is distributed in the hope that it will be useful, but        ##
## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
## or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   ##
## for more details.                                                          ##
##                                                                            ##
## You should have received a copy of the GNU General Public License          ##
## along with this program;  if not, write to the Free Software               ##
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA    ##
##                                                                            ##
##                                                                            ##
################################################################################
#
# File:
#   if4-addr-change
#
# Description:
# Verify the IPv4 connectivity isn't broken with changing IPv4 address
# many times
#    test01 - by ifconfig command
#
# Setup:
#   See ltp-yyyymmdd/testcases/network/stress/README
#
# Author:
#   Mitsuru Chinen <mitch@jp.ibm.com>
#
# History:
#	Oct 19 2005 - Created (Mitsuru Chinen)
#
#-----------------------------------------------------------------------
# Uncomment line below for debug output.
#trace_logic=${trace_logic:-"set -x"}
$trace_logic

# Make sure the value of LTPROOT
LTPROOT=${LTPROOT:-`(cd ../../../../ ; pwd)`}
export LTPROOT

# Total number of the test case
TST_TOTAL=1
export TST_TOTAL

# Default of the test case ID and the test case count
TCID=if4-addr-change
TST_COUNT=0
export TCID
export TST_COUNT

# Check the environmanet variable
. check_envval || exit $TST_TOTAL

# The total number of changing of IPv4 address
NS_TIMES=${NS_TIMES:-10000}

# The interval of the check interface activity
CHECK_INTERVAL=${CHECK_INTERVAL:-`expr $NS_TIMES \/ 100`}

# The number of the test link where tests run
LINK_NUM=0

# Network portion of the IPv4 address
IPV4_NETWORK=${IPV4_NETWORK-"10.0.0"}

# Netmask of for the tested network
IPV4_NETMASK="255.255.255.0"

# Broadcast address of the tested network
IPV4_BROADCAST=${IPV4_NETWORK}.255

# Host portion of the IPv4 address on the remote host
RHOST_IPV4_HOST=${RHOST_IPV4_HOST:-"1"}

# Minumum host portion of the IPv4 address on the local host
LHOST_IPV4_HOST_MIN=${LHOST_IPV4_HOST:-"2"}

# Maximum host portion of the IPv4 address on the local host
LHOST_IPV4_HOST_MAX="254"



#-----------------------------------------------------------------------
#
# NAME:
#   do_setup
#
# DESCRIPTION:
#   Make a IPv4 connectivity on the Test Link
#
# SET VALUES:
#   rhost_ipv4addr	- IPv4 Address of the remote host
#   lhost_ifname	- Interface name of the localhost
#
#-----------------------------------------------------------------------
do_setup()
{
    TCID=if4-addr-change
    TST_COUNT=0

    # Initialize the interfaces
    initialize_if lhost ${LINK_NUM}
    initialize_if rhost ${LINK_NUM}

    # Set IPv4 address to the interfaces
    set_ipv4addr lhost ${LINK_NUM} ${IPV4_NETWORK} ${LHOST_IPV4_HOST_MIN}
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to set an IPv4 address at the local host"
	exit $TST_TOTAL
    fi
    set_ipv4addr rhost ${LINK_NUM} ${IPV4_NETWORK} ${RHOST_IPV4_HOST}
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to set an IPv4 address at the remote host"
	exit $TST_TOTAL
    fi

    # IPv4 address of the remote host
    rhost_ipv4addr="${IPV4_NETWORK}.${RHOST_IPV4_HOST}"

    # Get the Interface name of local host
    lhost_ifname=`get_ifname lhost ${LINK_NUM}`
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to get the interface name at the local host"
	exit $TST_TOTAL
    fi
}



#-----------------------------------------------------------------------
#
# NAME:
#   do_cleanup
#
# DESCRIPTION:
#   Recover the tested interfaces
#
#-----------------------------------------------------------------------
do_cleanup()
{
    # Initialize the interfaces
    initialize_if lhost ${LINK_NUM}
    initialize_if rhost ${LINK_NUM}
}



#-----------------------------------------------------------------------
#
# FUNCTION:
#   test01
#
# DESCRIPTION:
#   ifconfig case
#
#-----------------------------------------------------------------------
test01()
{
    TCID=if4-addr-change01
    TST_COUNT=1
    tst_resm TINFO "Verify the IPv4 connectivity is not broken when the ifconfig command changes the IPv4 address $NS_TIMES times"

    # Check the connctivity
    check_icmpv4_connectivity $lhost_ifname $rhost_ipv4addr
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Test Link $LINK_NUM is something wrong."
	return 1
    fi

    # Start the loop
    cnt=0
    current_lhost_ipv4_host=$LHOST_IPV4_HOST_MIN
    while [ $cnt -lt $NS_TIMES ]; do
	# Define the network portion
	current_lhost_ipv4_host=`expr $current_lhost_ipv4_host + 1`
	if [ $current_lhost_ipv4_host -gt $LHOST_IPV4_HOST_MAX ]; then
	    current_lhost_ipv4_host=$LHOST_IPV4_HOST_MIN
	fi

	# Change the IPv4 address
	lhost_ipv4addr="${IPV4_NETWORK}.${current_lhost_ipv4_host}"
	ifconfig $lhost_ifname $lhost_ipv4addr netmask $IPV4_NETMASK broadcast $IPV4_BROADCAST
	if [ $? -ne 0 ]; then
	    test_resm TFAIL "Failed to change IPv4 address into ${lhost_ipv4addr}"
	    return 1
	fi

	# Check the connecitivity
	cnt=`expr $cnt + 1`
	if [ $CHECK_INTERVAL -ne 0 ]; then
	    if [ `expr $cnt % ${CHECK_INTERVAL}` -eq 0 ]; then
		check_icmpv4_connectivity $lhost_ifname $rhost_ipv4addr
		if [ $? -ne 0 ]; then
		    tst_resm TFAIL "$lhost_ifname is broken at around ${cnt} times"
		    return 1
		fi
	    fi
	fi
    done

    # Check the connectivity again.
    check_icmpv4_connectivity $lhost_ifname $rhost_ipv4addr
    if [ $? -ne 0 ]; then
	tst_resm TFAIL "$errmsg $lhost_ifname is broken."
	return 1
    fi

    tst_resm TPASS "Test is finished successfully."
    return 0
}



#-----------------------------------------------------------------------
#
# Main
#
# Exit Value:
#   The number of the failure
#
#-----------------------------------------------------------------------

RC=0
do_setup
test01 || RC=`expr $RC + 1`
do_cleanup

exit $RC
